<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="p-4 h-100">

  <app-breadcrumbs></app-breadcrumbs>

  <form class="ls-form">
    <h3 [innerText]="messages.FORM_TITLE"></h3>
    <div class="border shadow-sm">
      <div class="row h-100">
        <div class="create-folder-column col-sm p-4 border-end d-flex flex-column">

          <h4
            class="fw-bold"
            [innerText]="'Documents'">
          </h4>

          <div class="d-flex mb-2" aria-label="Add documents">
            <div class="form-group mb-0">
              <div id="mainDocuments" class="input-group">

                <ng-template #mainInputTooltip>
                  <span [innerText]="messages.mainDocumentMaxReached(parsedSelectedType, selectedSubtype)"></span>
                </ng-template>

                <input
                  type="file"
                  id="fileInput"
                  class="invisible-file-input"
                  name="fileIn"
                  [accept]="acceptedMimeTypesPrincipal"
                  (change)="onFileSelected($event)"
                  [disabled]="disableMainFileInput()"
                  [multiple]="getMaxDocumentsCountFn(parsedSelectedType, selectedSubtype) !== 1"
                  #mainFileInput="ngModel"
                  ngModel
                  required
                  autofocus="true">

                <label
                  class="btn btn-sm btn-outline-success rounded"
                  for="fileInput"
                  [ngClass]="{'disabled': disableMainFileInput()}"
                  [ngbTooltip]="mainInputTooltip"
                  [disableTooltip]="!disableMainFileInput()"
                  (fileDropped)="dragAndDropMainFiles($event)"
                  DragAndDrop>

                  <fa-icon
                    class="me-1"
                    [title]="commonMessages.ADD"
                    [icon]="commonIcons.ADD_ICON">
                  </fa-icon>
                  <span [innerText]="messages.addMainDocument(parsedSelectedType, selectedSubtype)"></span>

                </label>
              </div>
            </div>

            <div *ngIf="parsedSelectedType?.protocol !== protocolEnum.Helios" class="form-group mb-0">
              <div id="annexeDocuments" class="input-group">
                <ng-template #annexesInputTooltip>
                  <p [innerText]="messages.ANNEXE_DOC_MAX_REACHED"></p>
                </ng-template>

                <input
                  type="file"
                  id="annexeFileInput"
                  class="invisible-file-input"
                  name="annexeFileIn"
                  [accept]="acceptedMimeTypesAnnexe"
                  (change)="onAnnexeFileSelected($event)"
                  [disabled]="disableAnnexeFileInput()"
                  #annexeFileInput="ngModel"
                  multiple
                  ngModel>

                <label
                  class="mx-1 btn btn-sm btn-outline-primary rounded"
                  [ngClass]="{'disabled': disableAnnexeFileInput()}"
                  for="annexeFileInput"
                  [ngbTooltip]="annexesInputTooltip"
                  [disableTooltip]="!disableAnnexeFileInput()"
                  (fileDropped)="dragAndDropAnnexeFiles($event)"
                  DragAndDrop>

                  <fa-icon
                    class="me-1"
                    [title]="commonMessages.ADD"
                    [icon]="commonIcons.ADD_ICON">
                  </fa-icon>
                  <span [innerText]="messages.ADD_ANNEXE_DOCUMENTS"></span>

                </label>

              </div>
            </div>
          </div>

          <div>
            <label
              for="mainDocuments"
              [innerText]="messages.mainDocumentsSectionSubtitle(parsedSelectedType, selectedSubtype)">
            </label>

            <hr class="mt-0">

            <div
              (fileDropped)="dragAndDropMainFiles($event)"
              DragAndDrop>
              <div
                class="list-group drop-zone mb-2"
                cdkDropList
                [id]="mainFileListId"
                [cdkDropListData]="selectedMainDocumentsFiles"
                #mainFilesList="cdkDropList"
                [cdkDropListConnectedTo]="[annexeFilesList]"
                (cdkDropListDropped)="drop($event, selectedMainDocumentsFiles)">

                <div
                  class="list-group-item d-flex flex-row justify-content-between"
                  cdkDrag
                  [cdkDragData]="item"
                  *ngFor="let item of selectedMainDocumentsFiles; let i = index">

                  <div class="w-100 d-flex flex-row align-items-center">
                    <div *ngIf="i === 0">
                      <label for="mainFileInput" class="mb-0">
                        <fa-icon
                          class="text-primary"
                          [fixedWidth]="true"
                          [title]="commonMessages.REPLACE"
                          [icon]="faSyncAlt">
                        </fa-icon>
                      </label>

                      <input
                        type="file"
                        id="mainFileInput"
                        #mainFileInput="ngModel"
                        class="d-none"
                        name="mainFileIn"
                        [accept]="acceptedMimeTypesPrincipal"
                        (change)="changeMainFile($event)"
                        ngModel>
                    </div>
                    <fa-icon
                      *ngIf="i !== 0"
                      class="text-danger"
                      [fixedWidth]="true"
                      [title]="commonMessages.DELETE"
                      (click)="removeMainFile(i)"
                      [icon]="commonIcons.DELETE_ICON">
                    </fa-icon>

                    <fa-icon
                      *ngIf="(parsedSelectedType?.signatureFormat === signatureFormatEnum.Pades) && (item.file.type !== 'application/pdf')"
                      class="ms-2 text-info"
                      [fixedWidth]="true"
                      [icon]="infoCircleIcon"
                      [ngbTooltip]="messages.DOCUMENT_PDF_TRANSFORMATION_TOOLTIP">
                    </fa-icon>

                    <div
                      [ngbTooltip]="item.file.name"
                      [innerText]="item.file.name"
                      class="ms-2 text-overflow-ellipsis overflow-hidden w-100">
                    </div>
                    <div class="d-flex flex-row align-items-center">

                      <input
                        type="file"
                        id="detachedSignaturesInput-{{i}}"
                        class="d-none"
                        [accept]="mimeTypesDetachedSignature"
                        (change)="addDetachedSignature($event, item)"
                        multiple
                        ngModel
                        required
                        #detachedSignaturesInput="ngModel">

                      <div
                        ngbDropdown
                        container="body"
                        [autoClose]="'outside'"
                        #detachedSignatureDropdown="ngbDropdown">

                        <span
                          class="d-flex text-secondary dropdown-btn"
                          ngbDropdownAnchor
                          (click)="detachedSignatureDropdown.open()">
                          <fa-icon
                            class="me-2"
                            [icon]="faEllipsisV">
                          </fa-icon>
                        </span>

                        <div
                          class="detached-signature-dropdown"
                          ngbDropdownMenu
                          aria-labelledby="dropdownManual">
                          <span
                            class="mx-3 mt-2 fw-bold"
                            [innerText]="messages.DETACHED_SIGNATURES">
                          </span>
                          <div
                            ngbDropdownItem
                            class="ps-4 d-flex flex-row w-100"
                            *ngFor="let detachedSignature of item.detachedSignatures; let j = index">

                            <fa-icon
                              class="pe-2 delete-icon-secondary pointer"
                              [fixedWidth]="true"
                              [title]="commonMessages.DELETE"
                              (click)="removeDetachedSignature(i, j, detachedSignaturesInput)"
                              [icon]="commonIcons.DELETE_ICON">
                            </fa-icon>

                            <div
                              [innerText]="detachedSignature.name"
                              [ngbTooltip]="detachedSignature.name"
                              class="overflow-hidden text-overflow-ellipsis">
                            </div>
                          </div>
                          <span
                            class="ps-4"
                            ngbDropdownItem>
                            <label
                              class="m-0 text-nowrap pointer d-flex align-items-center"
                              for="detachedSignaturesInput-{{i}}">
                              <fa-icon
                                class="pe-2 text-secondary"
                                [fixedWidth]="true"
                                [icon]="commonIcons.ADD_ICON"
                                [title]="messages.ADD_DETACHED_SIGNATURE">
                              </fa-icon>

                              <span [innerText]="messages.ADD_DETACHED_SIGNATURE"></span>
                            </label>
                          </span>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <ng-container *ngIf="parsedSelectedType?.protocol !== protocolEnum.Helios">
              <div
                (fileDropped)="dragAndDropAnnexeFiles($event)"
                DragAndDrop>>
                <label
                  [innerText]="messages.ANNEXE_DOCUMENT_SECTION_SUBTITLE"
                  for="annexeDocuments">
                </label>
                <hr class="mt-0">
                <div
                  class="list-group drop-zone mb-2"
                  cdkDropList
                  [id]="annexeFileListId"
                  [cdkDropListData]="selectedAnnexesFiles"
                  #annexeFilesList="cdkDropList"
                  [cdkDropListConnectedTo]="[mainFilesList]"
                  (cdkDropListDropped)="drop($event, selectedAnnexesFiles)">

                  <div
                    class="list-group-item w-100 d-flex flex-row "
                    cdkDrag
                    [cdkDragData]="item" *ngFor="let item of selectedAnnexesFiles; let i = index">
                    <fa-icon
                      class="text-danger"
                      [fixedWidth]="true"
                      (click)="removeAnnexeFile(i)"
                      [icon]="commonIcons.DELETE_ICON">
                    </fa-icon>
                    <div
                      [innerText]="item.file.name"
                      [ngbTooltip]="item.file.name"
                      class="text-overflow-ellipsis overflow-hidden ms-2">
                    </div>
                  </div>
                </div>
              </div>
            </ng-container>
          </div>
        </div>
        <div class="create-folder-column col-sm p-4 border-end">
          <h4
            class="fw-bold"
            [innerText]="commonMessages.WORKFLOW_NAME">
          </h4>

          <div class="form-group required">
            <label
              for="typeSelector"
              [innerText]="commonMessages.TYPE">
            </label>
            <app-type-selector
              *ngIf="tenantId"
              id="typeSelector"
              [ngbTooltip]="selectedType?.name"
              [mandatory]="true"
              [retrieveTypesFunction]="retrieveTypesFn"
              [(type)]="selectedType"
              (typeChange)="onTypeSelectionChanged()">
            </app-type-selector>
          </div>

          <div class="form-group required">
            <label
              for="subtypeSelector"
              [innerText]="commonMessages.SUBTYPE">
            </label>
            <app-subtype-selector
              *ngIf="tenantId"
              id="subtypeSelector"
              [ngbTooltip]="selectedSubtype?.name"
              [mandatory]="true"
              [retrieveSubtypesFunction]="retrieveSubtypesFn"
              [tenantId]="tenantId"
              [type]="selectedType"
              [(subtype)]="selectedSubtype"
              [disabled]="selectedType == undefined"
              (subtypeChange)="onSubtypeSelectionChanged()">
            </app-subtype-selector>
          </div>
          <div class="mb-2">
            <span
              *ngIf="!showSteps() && !availableWorkflows() && !WorkflowUtils.hasSelectionScript(selectedSubtype)"
              class="text-danger"
              [innerText]="messages.NO_WORKFLOW_FOR_SUBTYPE">
            </span>
            <span
              *ngIf="WorkflowUtils.hasSelectionScript(selectedSubtype)"
              class="text-secondary"
              [innerText]="messages.SELECTION_SCRIPT_MESSAGE">
            </span>
          </div>

          <div *ngIf="showCreationSteps()">
            <div class="d-flex flex-column">
              <label
                for="creationSteps"
                [innerText]="commonMessages.WORKFLOW_STEPS_DEFINITION">
              </label>
              <span
                class="text-secondary ps-2 mb-1"
                [innerText]="commonMessages.CREATION_WORKFLOW">
              </span>
            </div>
            <app-workflow-steps
              id="creationSteps"
              [tenantId]="tenantId"
              [deskId]="currentDesk.id"
              [variableDesksIds]="variableDesksIds"
              [originDesk]="currentDesk"
              [workflowDefinition]="creationWorkflowDefinition"
              [showEnd]="false">
            </app-workflow-steps>
          </div>

          <div *ngIf="showSteps()">
            <div class="d-flex flex-column">
              <label
                *ngIf="!showCreationSteps()"
                for="validationSteps"
                [innerText]="commonMessages.WORKFLOW_STEPS_DEFINITION">
              </label>
              <span
                *ngIf="showCreationSteps()"
                class="text-secondary ps-2 mb-2 mt-2"
                [innerText]="commonMessages.VALIDATION_WORKFLOW">
              </span>
            </div>
            <app-workflow-steps
              id="validationSteps"
              [tenantId]="tenantId"
              [deskId]="currentDesk.id"
              [variableDesksIds]="variableDesksIds"
              [workflowDefinition]="validationWorkflowDefinition"
              [showStart]="!creationWorkflowDefinition"
              [originDesk]="currentDesk"
              [stepOffset]="creationWorkflowDefinition?.steps?.length">
            </app-workflow-steps>
          </div>

          <div
            *ngIf="selectedType && (selectedSubtype?.subtypeMetadataList?.length > 0) && tenantId"
            class="mt-4">

            <h4
              [innerText]="commonMessages.METADATA_NAME_PLURAL">
            </h4>

            <div
              *ngFor="let subtypeMetadata of selectedSubtype.subtypeMetadataList"
              id="metadata"
              class="form-group"
              [ngClass]="{ 'required': subtypeMetadata.mandatory }">

              <label [innerText]="subtypeMetadata.metadata.name"></label>
              <app-metadata-input
                [type]="subtypeMetadata.metadata.type"
                [restrictedValues]="subtypeMetadata.metadata.restrictedValues"
                [defaultValue]="subtypeMetadata.defaultValue"
                [editable]="true"
                [mandatory]="subtypeMetadata.mandatory"
                [(value)]="metadata[subtypeMetadata.metadata.key]"
                (valueChange)="metadataWasUpdated()">
              </app-metadata-input>
            </div>
          </div>

        </div>
        <div class="create-folder-column col-sm p-4">
          <h4
            class="fw-bold"
            [innerText]="messages.GENERAL_INFORMATION_TITLE">
          </h4>

          <div class="form-group required">
            <div class="d-flex flex-row">
              <label
                for="nameInput"
                [innerText]="messages.GENERAL_INFORMATION_FORM_NAME">
              </label>
            </div>

            <input
              id="nameInput"
              name="nameIn"
              class="form-control"
              type="text"
              [(ngModel)]="name"
              #nameInput="ngModel"
              required
              minlength="2">
            <div
              *ngIf="nameInput.invalid && (nameInput.dirty || nameInput.touched)"
              class="w-100 text-warning mt-2">
              <fa-icon
                class="pe-2"
                [icon]="commonIcons.INVALID_FORM_ICON">
              </fa-icon>
              <span
                *ngIf="nameInput.errors.required || nameInput.errors.minlength"
                [innerText]="messages.GENERAL_INFORMATION_FORM_ERROR_MUST_HAVE_NAME_AND_NOT_TOO_SHORT">
              </span>
            </div>
          </div>

          <div class="form-group" *ngIf="globalSettings.user.folderVisibility.length > 0">
            <label [innerText]="messages.GENERAL_INFORMATION_FORM_VISIBILITY"></label>
            <div>
              <button
                *ngFor="let visibility of globalSettings.user.folderVisibility"
                class="me-1 mb-1 btn btn-outline-primary pe-4 ps-4 {{ selectedVisibility === visibility ? 'active' : '' }}"
                (click)="selectedVisibility = visibility"
                [innerText]="visibility | folderVisibilityName"
                [disableTooltip]="globalSettings.user.folderVisibility.length > 1"
                [ngbTooltip]="messages.UNIQUE_VISIBILITY_WARNING_TOOLTIP">
              </button>
            </div>
          </div>

          <div class="form-group">
            <label
              for="limit-date"
              [innerText]="commonMessages.DUE_DATE">
            </label>
            <div class="input-group">
              <input
                id="limit-date"
                class="form-control"
                name="limit-date"
                type="date"
                [(ngModel)]="limitDate">
            </div>
          </div>
        </div>
      </div>

      <div class="border-top p-4 text-end d-flex justify-content-end">
        <button
          ls-button-cancel
          [disabled]="isProcessing"
          routerLink="..">
        </button>
        <button
          ls-button-cancel
          class="mx-1"
          [disabled]="!isValid() || isProcessing"
          [text]="messages.SAVE_AS_DRAFT"
          [processing]="isProcessing"
          (click)="createDraftFolder()">
        </button>
        <button
          ls-button
          class="mx-1"
          [disabled]="!isValid() || !WorkflowUtils.everyMandatoryMetadataIsSet(selectedSubtype, metadata) || isProcessing"
          [icon]="actionEnum.Start | actionIcon"
          [text]="actionEnum.Start | actionName"
          [processing]="isProcessing"
          (click)="createAndStartFolder()">
        </button>
      </div>
    </div>
  </form>

</div>
